package edu.nps.seed.nst

import java.io.File
import java.io.PrintWriter


object EventLogger {

  def outputEvents(filename: String): Unit = {
	val taskEventFileName = filename + ".tasks"
 
	outputTo(new File(taskEventFileName), Task.toEventList)
 
  }
  
  def outputTo(file: File, data: List[String]): Unit = {
  	  val writer = new PrintWriter(file)
	  try {
        //write header (first line) + values
        for (line <- data)
        	writer.println(line)
	  } finally {
	    writer.close()
	  }   
    
  }
  
}
