/*
    
    oldmcdata1.0
    Copyright (C) 2005 Referentia Systems, Inc.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
package oldmcdata.analyzers.tests;

import oldmcdata.analyzers.utils.DataSelector;

import org.dom4j.DocumentHelper;
import org.dom4j.Element;

/**
 * @author Stephen C. Upton
 * @date Feb 22, 2005
 *
 */
public class DataSelectorTest {
    private Element dataSelectorElement;
    private String filename;
    
    public DataSelectorTest(String filename) {
        this.filename = filename;
    }
    
    public void constructTestElement() {
        dataSelectorElement = DocumentHelper.createElement("DataSelector");
        Element skipLines = dataSelectorElement.addElement("SkipLines");
        Element numberToSkip = skipLines.addElement("Number");
        numberToSkip.setText("6");
        Element starts1 = skipLines.addElement("StartsWith");
        starts1.setText("#");
        Element starts2 = skipLines.addElement("StartsWith");
        starts2.setText("Means");
        Element starts3 = skipLines.addElement("StartsWith");
        starts3.setText("Std");
        
        Element selectColumns = dataSelectorElement.addElement("SelectCols");
        Element colElement1 = selectColumns.addElement("Col");
        Element name1 = colElement1.addElement("name");
        name1.setText("name1");
        Element number1 = colElement1.addElement("number");
        number1.setText("3");
        Element colElement2 = selectColumns.addElement("Col");
        Element name2 = colElement2.addElement("name");
        name2.setText("name2");
        Element number2 = colElement2.addElement("number");
        number2.setText("4");
        System.out.println("Element");
        System.out.println(dataSelectorElement.asXML());
        
    }
    
    public void runTest() {
        constructTestElement();
        DataSelector r = new DataSelector();
        r.initialize(dataSelectorElement);
        r.setFileToProcess(filename);
        r.processData();
        System.out.println("Output");
        System.out.println(r.toString());
    }
    
    public static void main(String[] args) {
        System.out.println("Running DataSelectorTest");
        DataSelectorTest t = new DataSelectorTest(args[0]);
        t.runTest();
        System.out.println("Completed DataSelectorTest"); 
    }
}
