/**
 * 
 */
package oldmcdata.evaluators;

import java.util.ArrayList;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.List;

import org.dom4j.Element;

/**
 * @author stephenupton
 *
 */
public class CommandLineJobRunner implements JobRunner {
    private List<String> cmdarray;

    public CommandLineJobRunner() {
    }
    
    @SuppressWarnings("unchecked")
    public void run(List cmdLines) {
        Iterator cmds = cmdLines.iterator();
        while (cmds.hasNext()) {
            Object commandLine = cmds.next();
//            if (commandLine instanceof List)
//                constructCommandLine((List<String>) commandLine);
            if (commandLine instanceof Element)
                constructCommandLine((Element) commandLine);
            runCommandLine();
        }
    }

    /** handles a Element of a List of Elements as the command line arguments
     */
	@SuppressWarnings("unchecked")
    private void constructCommandLine(Element cmdLine) {
        List<Element> arguments = cmdLine.elements("argument");
        cmdarray = new ArrayList<String>();
        for (int i = 0; i < arguments.size(); i++) {
            Element argument = (Element) arguments.get(i);
            cmdarray.add(argument.getTextTrim());
        }
    }

    /** handles a List of a List of Strings as the command line arguments
     */
//	@SuppressWarnings("unchecked")
//    private void constructCommandLine(List<String> arguments) {
//        cmdarray = new String[arguments.size()];
//        for (int i = 0; i < arguments.size(); i++) {
//            cmdarray[i] = (String) arguments.get(i);
//        }
//    }


    public void runCommandLine() {
		boolean err = false;
        System.out.println("Command Line: ");
        for (String cmd : cmdarray ) {
        	System.out.print(cmd + " ");	
        }
            
        System.out.println();
   		
        try {
        	Process pp = new ProcessBuilder(cmdarray).start();
        	BufferedReader results = new BufferedReader(
        			new InputStreamReader(pp.getInputStream()));
        	String s;
        	while ((s = results.readLine()) != null)
        		System.out.println(s);
        	BufferedReader errors = new BufferedReader(
        			new InputStreamReader(pp.getErrorStream()));
        	while ((s = errors.readLine()) != null ) {
        		System.err.println(s);
        		err = true;
        	}
        	pp.waitFor();

        } catch (Exception ex) {
            ex.printStackTrace(System.out);
            System.exit(-1);
        }
        
		if (err)
			throw new RuntimeException("Errors executing command: " + cmdarray); 

    }

}
