package oldmcdata.generators;


import java.util.List;

import org.dom4j.Element;


/**
 * Title:
 * Description:
 *Copyright: 2000 - 2005
 *  
 * @author Stephen C. Upton
 * @version 1.3
 */


interface AlgorithmStep {
    boolean execute();
}

public abstract class NaturalHeuristicGenerator extends AbstractGenerator {
    protected final static String NUMBEROFEXCURSIONS = "NumberOfExcursions",
    NUMBEROFITERATIONS = "NumberOfIterations",
    DELIMITER = "Delimiter",
    DEFAULTDELIMITER = ",",
    MAXIMUMVALUE = "MaximumValue",
    MINIMUMVALUE = "MinimumValue";
    protected long iterationCount = -1L;
    protected int numberOfExcursions;
    protected int numberOfIterations;
    protected List excursions;
    protected String delim;
    protected boolean stop = false;
    protected Element parameters;

    public NaturalHeuristicGenerator() {
        super();
        // defaults
        numberOfExcursions = 1;
        numberOfIterations = 1;
        delim = DEFAULTDELIMITER;
    }


    public void initialize() {
        System.out.println(this.getClass().getName() + ":initialize()");
        translator.initialize();
        try {
            configure();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }

    protected void configure() {
        parameters = studyXMLHandler.getGeneratorAlgorithmParameters();
        Element numOfExcursions = parameters.element(NUMBEROFEXCURSIONS);
        Element numOfIterations = parameters.element(NUMBEROFITERATIONS);
        Element delimiter = parameters.element(DELIMITER);
        // if any of these parameters are null, use defaults as specified in constructor
        if (numOfIterations != null)
            setNumberOfIterations(numOfIterations.getText());
        if (numOfExcursions != null)
            setNumberOfExcursions(numOfExcursions.getText());
        if (delimiter != null)
            setDelimiter(delimiter.getText());
    }

    public void setNumberOfExcursions(String noe) {
        numberOfExcursions = Integer.parseInt(noe);
    }

    public void setNumberOfIterations(String noi) {
        numberOfIterations = Integer.parseInt(noi);
    }

    public void setDelimiter(String d) {
        delim = d;
    }

    public abstract boolean generate();

}
